U.GuiObjects = (function() {
    var obj = {};
    var repo = Lib.createRepo();

    function BallNumber() {
        var self = this;
        var group = U.GLOB.GROUPS.gui;
        var backTex = "ballNumberBackground";
        var pos = new Phaser.Point(400, -200);
        var textOffset = new Phaser.Point(95, 8);
        this.textVal = U.STATS.availableBalls;
        var maxVal = U.STATS.maxBalls;

        var plusTexture = "";
        var plusAlphaTween = undefined;
        var plusObject = undefined;
        var plusObjectEvent = undefined;

        function _createTravellingNumber() {
            var plusObjectPos = new Phaser.Point(pos.x + 80, pos.y + 70);
            plusObject = Lib.UTILS.createImageInGroup(plusObjectPos.x, plusObjectPos.y, plusTexture, group);
            plusObject.alpha = 0;
            plusObject.anchor.setTo(0.5, 0.5);

            plusAlphaTween = game.add.tween(plusObject);
            plusAlphaTween.to({
                alpha: 1
            }, Phaser.Timer.SECOND * 0.5, Phaser.Easing.Quadratic.Out);
            plusAlphaTween.to({
                y: pos.y + 50 - 30,
                width: plusObject.width * 0.1,
                height: plusObject.height * 0.1,
                alpha: 0
            }, Phaser.Timer.SECOND * 0.5, Phaser.Easing.Quadratic.Out);

            plusAlphaTween.onComplete.add(_destroyPlusObj, self);

            plusAlphaTween.start();

            //finishers
            U.LocalFx.smallGuiFx(plusObjectPos.x, plusObjectPos.y, 0.3, "smallGuiFxYellow");
        }

        function _setNewVal(newVal) {
            self.textVal = newVal;
            if (self.textVal > maxVal) {
                self.textVal = maxVal;
            }
            if (self.textVal < 0) {
                self.textVal = 0;
            }
            var text = self.textVal.toString();
            self.objText.setText(text);

        }

        function _destroyPlusObj() {
            //destroy travelling object
            if (Lib.check.exists(plusObject)) {
                p("DESTROYNIG OBJ");
                plusObject.destroy();
            }

        }
        // this.objBackground = Lib.UTILS.createImageInGroup(pos.x,pos.y,backTex,group);
        this.objBackground = new Lib.Gui.Image({
            x: pos.x,
            y: pos.y,
            texture: backTex,
            group: group
        });

        this.objText = new Lib.Gui.Text({
            x: pos.x + textOffset.x,
            y: pos.y + textOffset.y,
            text: self.textVal.toString(),
            style: {
                font: "25px peace_sans",
                fill: "#fbff8d",
                // fill: "#efffb9",
                stroke: "#322213",
                strokeThickness: 4
            },
            group: group
        });

        this.setVal = function(newVal) {
            // p("SET VAL CALLED");
            //Positive ball. Create travelling object
            if (newVal > self.textVal) {
                // p("POSITIVE VAL");
                plusTexture = _getTexBasedOnVal(newVal - self.textVal);
                p("INCREASING BY " + (newVal - self.textVal).toString());
                _createTravellingNumber();
                plusObjectEvent = game.time.events.add(Phaser.Timer.SECOND * 1, _setNewVal, self, newVal);
            }
            //negative ball. Instantly decrease
            else {
                // p("NEGATIVE VAL");
                _setNewVal(newVal);
            }
        }

        this.setAbsVal = function(newVal) {
            _setNewVal(newVal);
        }

        function _getTexBasedOnVal(val) {
            var tex = "";
            if (val === 1) {
                tex = "ballPlusOne";
            }
            else if (val === 2) {
                tex = "ballPlusTwo";
            }

            return tex;
        }

        // STANDARD REPO CODE - ----------------------------------------
        repo.addObj(this);
        this.destroyWasCalled = false;
        //REQUIRED-----------------
        this.destroy = function() {
            if (!self.destroyWasCalled) {
                repo.removeObj(self);
                self.destroyWasCalled = true;

                self.objBackground.destroy();
                self.objText.destroy();
                game.time.events.remove(plusObjectEvent);

                if (Lib.check.exists(plusObject)) {
                    plusObject.destroy();
                }

            }
        }

        this._update = function() {
            setYBasedONTweeningY();
        }

        //#######################
        this.tweeningY = pos.y;
        var oldTweeningY = self.tweeningY;
        var showPos = new Phaser.Point(400, 4);
        var hidePos = new Phaser.Point(400, -200);

        function setYBasedONTweeningY() {
            if (oldTweeningY !== self.tweeningY) {
                _setY(self.tweeningY);
                oldTweeningY = self.tweeningY;
            }
        }

        function _setY(y) {
            self.objBackground.obj.y = y;
            self.objText.obj.y = y + textOffset.y;
        }

        //AUTO HIDE SHOW
        var showTween = game.add.tween(self);

        this.show = function(seconds = 0.5) {
            showTween.manager.remove(showTween);
            showTween = game.add.tween(self);
            showTween.to({
                tweeningY: showPos.y
            }, Phaser.Timer.SECOND * seconds, Phaser.Easing.Quadratic.Out);
            showTween.start();
        }

        this.hide = function(seconds = 0.5) {
            // showTween.stop();
            showTween.manager.remove(showTween);
            showTween = game.add.tween(self);
            showTween.to({
                tweeningY: hidePos.y
            }, Phaser.Timer.SECOND * seconds, Phaser.Easing.Quadratic.In);
            showTween.start();
        }

        //
        // _setY(300);
    }


    function PauseButton() {
        var self = this;
        var group = U.GLOB.GROUPS.gui;
        var showPos = new Phaser.Point(665, 9);
        var hidePos = new Phaser.Point(665, -200);
        var tex = "pauseButton";


        this.pauseButtonObj = new Lib.Gui.Button({
            x: hidePos.x,
            y: hidePos.y,
            texture: tex,
            group: group,
            callback: U.GLOB.FACTORY.stateManager.pauseClickedFromMainGame,
            context: U.GLOB.FACTORY.stateManager.context
        });
        this.pauseButtonObj.obj.anchor.setTo(0, 0);

        U.GLOB.BUTTONS.pauseFromGameplay = this.pauseButtonObj;


        // STANDARD REPO CODE - ----------------------------------------
        repo.addObj(this);
        this.destroyWasCalled = false;
        //REQUIRED-----------------
        this.destroy = function() {
            if (!self.destroyWasCalled) {
                repo.removeObj(self);
                self.destroyWasCalled = true;
                self.pauseButtonObj.obj.destroy();

            }
        }

        this._update = function() {
            setYBasedONTweeningY();
        }

        this.tweeningY = hidePos.y;
        var oldTweeningY = self.tweeningY;

        function setYBasedONTweeningY() {
            if (oldTweeningY !== self.tweeningY) {
                _setY(self.tweeningY);
                // self.pauseButonObj.obj.y = self.tweeningY ;
                oldTweeningY = self.tweeningY;
            }
        }

        function _setY(y) {
            self.pauseButtonObj.obj.y = y;
        }


        //AUTO HIDE SHOW
        var showTween = game.add.tween(self);

        this.show = function(seconds = 0.5) {
            showTween.manager.remove(showTween);
            showTween = game.add.tween(self);
            showTween.to({
                tweeningY: showPos.y
            }, Phaser.Timer.SECOND * seconds, Phaser.Easing.Quadratic.Out);
            showTween.start();
        }

        this.hide = function(seconds = 0.5) {
            // showTween.stop();
            showTween.manager.remove(showTween);
            showTween = game.add.tween(self);
            showTween.to({
                tweeningY: hidePos.y
            }, Phaser.Timer.SECOND * seconds, Phaser.Easing.Quadratic.In);
            showTween.start();
        }

    }

    function ScoreNumber() {
        var self = this;
        var group = U.GLOB.GROUPS.gui;
        var backTex = "scoreBackground";
        var pos = new Phaser.Point(530, -200);
        var textOffset = new Phaser.Point(100, 8);
        this.textVal = U.STATS.availableBalls;
        var maxVal = U.STATS.maxBalls;

        // this.objBackground = Lib.UTILS.createImageInGroup(pos.x,pos.y,backTex,group);
        this.objBackground = new Lib.Gui.Image({
            x: pos.x,
            y: pos.y,
            texture: backTex,
            group: group
        });

        this.objText = new Lib.Gui.ScoreText({
            x: pos.x + textOffset.x,
            y: pos.y + textOffset.y,
            text: self.textVal.toString(),
            style: {
                font: "25px peace_sans",
                fill: "#c2ff2e",
                stroke: "#322213",
                strokeThickness: 4
            },
            valueGetter: U.STATS.getCurrentScore,
            group: group
        });

        var travellingText = undefined;
        this.addScore = function(val) {
            var pos = new Phaser.Point(140, 130);

            var textSize = _getTextSizeBasedOnVal(val);
            var fill = _getFillBasedOnVal(val);
            var fxScale = _getFxScaleBasedOnVal(val);

            //USE A CUSTOM TEXTURE
            U.LocalFx.smallGuiFx(pos.x, pos.y, fxScale, "smallGuiFx", 80);
            // p("Adding Score " + val);
            travellingText = new Lib.Gui.TravellingText({
                x: pos.x,
                y: pos.y,
                style: {
                    font: textSize + "px peace_sans",
                    fill: fill,
                    stroke: "#322213",
                    strokeThickness: 4
                },
                text: "+ " + val.toString(),
                group: U.GLOB.GROUPS.gui

            });


        }

        function _getTextSizeBasedOnVal(val) {
            var textSize = "25";
            if (val < 16) {
                textSize = "25";
            }
            else if (val >= 16 && val < 30) {
                textSize = "27";
            }
            else if (val >= 30 && val < 100) {
                textSize = "30";
            }
            else if (val >= 100 && val < 200) {
                textSize = "33";
            }
            else if (val >= 200 && val < 500) {
                textSize = "35";
            }
            else if (val >= 500) {
                textSize = "40";
            }
            return textSize;
        }

        function _getFillBasedOnVal(val) {
            var fill = "#fcff08";
            if (val < 16) {
                fill = "#fcff08";
            }
            else if (val >= 16 && val < 30) {
                fill = "#b1ff08";
            }
            else if (val >= 30 && val < 100) {
                fill = "#76ff08";
            }
            else if (val >= 100 && val < 500) {
                fill = "#08f0ff";
            }
            else if (val >= 500) {
                fill = "#ff0882";
            }
            return fill;

        }

        function _getFxScaleBasedOnVal(val) {

            var scale = 0.4;
            if (val < 16) {
                scale = 0.4;
            }
            else if (val >= 16 && val < 30) {
                scale = 0.5;
            }
            else if (val >= 30 && val < 100) {
                scale = 0.7;
            }
            else if (val >= 100 && val < 500) {
                scale = 0.8;
            }
            else if (val >= 500) {
                scale = 1;
            }
            return scale;
        }

        // STANDARD REPO CODE - ----------------------------------------
        repo.addObj(this);
        this.destroyWasCalled = false;
        //REQUIRED-----------------
        this.destroy = function() {
            if (!self.destroyWasCalled) {
                repo.removeObj(self);
                self.destroyWasCalled = true;

                self.objBackground.destroy();
                self.objText.destroy();
                if (Lib.check.exists(travellingText)) {
                    travellingText.destroy();
                }


            }
        }

        this._update = function() {
            setYBasedONTweeningY();
        }


        //#######################
        this.tweeningY = pos.y;
        var oldTweeningY = self.tweeningY;
        var showPos = new Phaser.Point(400, 4);
        var hidePos = new Phaser.Point(400, -200);

        function setYBasedONTweeningY() {
            if (oldTweeningY !== self.tweeningY) {
                _setY(self.tweeningY);
                oldTweeningY = self.tweeningY;
            }
        }

        function _setY(y) {
            self.objBackground.obj.y = y;
            self.objText.obj.y = y + textOffset.y;
        }

        //AUTO HIDE SHOW
        var showTween = game.add.tween(self);

        this.show = function(seconds = 0.5) {
            showTween.manager.remove(showTween);
            showTween = game.add.tween(self);
            showTween.to({
                tweeningY: showPos.y
            }, Phaser.Timer.SECOND * seconds, Phaser.Easing.Quadratic.Out);
            showTween.start();
        }

        this.hide = function(seconds = 0.5) {
            // showTween.stop();
            showTween.manager.remove(showTween);
            showTween = game.add.tween(self);
            showTween.to({
                tweeningY: hidePos.y
            }, Phaser.Timer.SECOND * seconds, Phaser.Easing.Quadratic.In);
            showTween.start();
        }

    }

    function ComboGraphic(val) {

        if (val < 2) {
            return -1;
        }

        U.GLOB.FACTORY.music.comboAppear.play();

        var self = this;
        var randPos = true;
        var group = U.GLOB.GROUPS.gui;
        var tex = _getTexBasedOnVal(val);
        // var tex = "comboExperimental";
        var pos = new Phaser.Point(200, 200);
        if (randPos) {
            pos = new Phaser.Point(Lib.UTILS.randInt(50, 300), Lib.UTILS.randInt(150, 250));
        }
        var distance = 50;

        var obj = Lib.UTILS.createImageInGroup(pos.x, pos.y, tex, group);

        // var anim = obj.animations.add(tex);
        // anim.play(35,true);

        var inertiaTweenData = [10, -5, 0];
        var offsetMultiplier = 3;
        var inverseSpeed = 0.15;

        var disappearTween = undefined;
        var disappearDistance = -70;
        var disappearEvent = undefined;
        var disappearSeconds = 1;

        Lib.animFx.travelTo({
            x: pos.x,
            y: pos.y + distance,
            inverseSpeed: inverseSpeed,
            type: Lib.DEFS.ANIM_FX.TRAVEL_TO.INERTIA,
            inertiaTweenData: inertiaTweenData,
            offsetMultiplier: offsetMultiplier,
            obj: obj
        });

        function _goUpDisappearSelfDestroy() {
            // p("GO UP AND SELF DESTROY");
            disappearTween = game.add.tween(obj);
            disappearTween.to({
                alpha: 0,
                y: pos.y + disappearDistance
            }, Lib.DEFS.SECOND * 0.3, Phaser.Easing.Quadratic.Out);

            disappearTween.start();

            disappearTween.onComplete.add(_destroy, this);
        }

        function _destroy() {
            // p("CALLING DESTROY *********************");
            if (Lib.check.exists.disappearTween) {
                disappearTween.stop();
            }
            // obj.destroy();
            if (Lib.check.exists(obj)) {
                obj.destroy();
            }

            if (Lib.check.exists(disappearEvent)) {
                game.time.events.remove(disappearEvent);
            }
        }

        //UTILITY FUNCS
        function _getTexBasedOnVal(val) {
            var tex = "combo2";
            if (val >= 2 && val <= 10) {
                tex = "combo" + val.toString();
            }
            else if (val >= 11 && val <= 12) {
                tex = "comboMega";
            }
            else if (val >= 13 && val <= 14) {
                tex = "comboSuperMega";
            }
            else if (val >= 15) {
                tex = "comboFantastic";
            }
            return tex;
        }

        // STANDARD REPO CODE - ----------------------------------------
        repo.addObj(this);
        this.destroyWasCalled = false;
        //REQUIRED-----------------
        this.destroy = function() {
                if (!self.destroyWasCalled) {
                    _goUpDisappearSelfDestroy();
                    self.destroyWasCalled = true;
                }
            }
            //OPTIONAL--------------------

        this._update = function() {
            // p("Im a BOx Emitter");
        }

        //finishing calls
        disappearEvent = game.time.events.add(Phaser.Timer.SECOND * disappearSeconds, _goUpDisappearSelfDestroy, this);

    }

    function ScoreMultiplier() {
        var self = this;
        var group = U.GLOB.GROUPS.gui;
        var tex = "";
        var obj = undefined;
        var pos = new Phaser.Point(650, 40);
        var tween = undefined;
        var currentTex = "";

        this.showScoreMultiplier = function(val, withFx = true) {

            tex = _getTexBasedOnVal(val);
            if (tex === currentTex) {
                return 0;
            }

            _deletePreviousMultiplier();
            p("SHOWING SCORE MULTIPLIER " + val);
            obj = Lib.UTILS.createImageInGroup(pos.x, pos.y, tex, group);
            obj.anchor.x = 1;
            obj.anchor.y = 0;
            obj.alpha = 0;

            tween = game.add.tween(obj);
            tween.to({
                alpha: 1
            }, Phaser.Timer.SECOND * 0.5, Phaser.Easing.Quadratic.Out);

            tween.start();

            currentTex = tex;

            if (withFx)
                U.LocalFx.smallGuiFx(obj.x - obj.width / 2, obj.y + obj.height / 2, 0.3, "smallGuiFxYellow", 50);

        }

        function _deletePreviousMultiplier() {
            if (Lib.check.exists(obj)) {
                tween.stop();
                obj.destroy();
            }
        }

        function _getTexBasedOnVal(val) {
            var tex = "";
            if (val === 2) {
                tex = "x2";
            }
            else if (val === 3) {
                tex = "x3";
            }
            else if (val === 4) {
                tex = "x4"
            }
            else if (val === 5) {
                tex = "x5";
            }
            else if (val === 6) {
                tex = "x6";
            }
            else if (val > 6 && val <= 9) {
                tex = "x10";
            }
            else if (val === 10) {
                tex = "x20";
            }
            else if (val > 10 && val <= 12) {
                tex = "x30";
            }
            else if (val > 12 && val <= 14) {
                tex = "x50";
            }
            else if (val > 14) {
                tex = "x100";
            }
            return tex;
        }

        // STANDARD REPO CODE - ----------------------------------------
        repo.addObj(this);
        this.destroyWasCalled = false;
        //REQUIRED-----------------
        this.destroy = function() {
                if (!self.destroyWasCalled) {
                    p("DESTORYNIG SCORE MULT");
                    repo.removeObj(self);
                    self.destroyWasCalled = true;

                    if (Lib.check.exists(obj)) {
                        tween.stop();
                        obj.destroy();
                    }
                }
            }
            //OPTIONAL--------------------

        this._update = function() {
            // p("Im a BOx Emitter");
        }

    }

    function GameDiff() {
        var self = this;
        var group = U.GLOB.GROUPS.gui;
        var tex = "diffEasy";
        var obj = undefined;
        var pos = new Phaser.Point(390, 32);
        var tween = undefined;
        var currentTex = "";

        this.showDiff = function(diff, withFx = true) {
            tex = _getTexBasedOnDiff(diff);

            if (tex === currentTex) {
                return 0;
            }

            _deletePreviousDiff();
            obj = Lib.UTILS.createImageInGroup(pos.x, pos.y, tex, group);
            obj.anchor.x = 1;
            obj.anchor.y = 0.5;
            obj.alpha = 0;

            tween = game.add.tween(obj);
            tween.to({
                alpha: 1
            }, Phaser.Timer.SECOND * 0.5, Phaser.Easing.Quadratic.Out);

            tween.start();

            currentTex = tex;

            if (withFx)
                U.LocalFx.smallGuiFx(obj.x - obj.width / 2, obj.y, 0.4, "smallGuiFxYellow", 50);

        }

        function _deletePreviousDiff() {
            if (Lib.check.exists(obj)) {
                tween.stop();
                obj.destroy();
            }
        }


        function _getTexBasedOnDiff(diff) {
            var tex = "";
            if (diff === U.STATS.diffType.EASY) {
                tex = "diffEasy";
            }
            else if (diff === U.STATS.diffType.MEDIUM) {
                tex = "diffMedium";
            }
            else if (diff === U.STATS.diffType.HARD) {
                tex = "diffHard";
            }
            else if (diff === U.STATS.diffType.VERY_HARD) {
                tex = "diffVeryHard";
            }
            return tex;
        }

        // STANDARD REPO CODE - ----------------------------------------
        repo.addObj(this);
        this.destroyWasCalled = false;
        //REQUIRED-----------------
        this.destroy = function() {
                if (!self.destroyWasCalled) {
                    p("DESTORYNIG SCORE MULT");
                    repo.removeObj(self);
                    self.destroyWasCalled = true;

                    if (Lib.check.exists(obj)) {
                        tween.stop();
                        obj.destroy();
                    }
                }
            }
            //OPTIONAL--------------------

        this._update = function() {
            // p("Im a BOx Emitter");
        }

        //finishing calls
        // this.showDiff(U.STATS.diff);
    }


    function BaseScore() {
        var self = this;
        var group = U.GLOB.GROUPS.gui;
        var tex = "score3";
        var obj = undefined;
        var pos = new Phaser.Point(515, 40);
        var tween = undefined;
        var currentTex = "";

        this.showBaseScore = function(diff, withFx = true) {
            tex = _getTexBasedOnDiff(diff);

            if (tex === currentTex) {
                return 0;
            }

            _deletePreviousDiff();
            obj = Lib.UTILS.createImageInGroup(pos.x, pos.y, tex, group);
            obj.anchor.x = 0;
            obj.anchor.y = 0;
            obj.alpha = 0;

            tween = game.add.tween(obj);
            tween.to({
                alpha: 1
            }, Phaser.Timer.SECOND * 0.5, Phaser.Easing.Quadratic.Out);

            tween.start();

            currentTex = tex;

            if (withFx)
                U.LocalFx.smallGuiFx(obj.x + obj.width / 2, obj.y + obj.height / 2, 0.4, "smallGuiFxYellow", 50);

        }

        function _deletePreviousDiff() {
            if (Lib.check.exists(obj)) {
                tween.stop();
                obj.destroy();
            }
        }


        function _getTexBasedOnDiff(diff) {
            var tex = "";
            if (diff === U.STATS.diffType.EASY) {
                tex = "score3";
            }
            else if (diff === U.STATS.diffType.MEDIUM) {
                tex = "score5";
            }
            else if (diff === U.STATS.diffType.HARD) {
                tex = "score10";
            }
            else if (diff === U.STATS.diffType.VERY_HARD) {
                tex = "score20";
            }
            return tex;
        }

        // STANDARD REPO CODE - ----------------------------------------
        repo.addObj(this);
        this.destroyWasCalled = false;
        //REQUIRED-----------------
        this.destroy = function() {
                if (!self.destroyWasCalled) {
                    p("DESTORYNIG SCORE MULT");
                    repo.removeObj(self);
                    self.destroyWasCalled = true;

                    if (Lib.check.exists(obj)) {
                        tween.stop();
                        obj.destroy();
                    }
                }
            }
            //OPTIONAL--------------------

        this._update = function() {
            // p("Im a BOx Emitter");
        }

        //finishing calls
        // this.showBaseScore(U.STATS.diff);
    }


    function BonusIndicator() {
        var self = this;
        var group = U.GLOB.GROUPS.gui;
        var tex = "bonusIndicator";
        var obj = undefined;
        var pos = new Phaser.Point(140, 120);
        var tween = undefined;
        var tweenRepeat = undefined;
        var travelDistance = 15;

        this.showBonusIndicator = function() {
            obj = Lib.UTILS.createImageInGroup(pos.x, pos.y, tex, group);
            obj.alpha = 1;
            obj.anchor.x = 0.5;
            obj.anchor.y = 0.5;

            tweenRepeat = game.add.tween(obj);
            // tweenRepeat.to({pos.y + travelDistance}, Phaser.Timer.SECOND * 2, Phaser.Easing.Quadratic.InOut);
            tweenRepeat.to({
                y: pos.y + travelDistance
            }, Phaser.Timer.SECOND * 0.3, Phaser.Easing.Linear.InOut);
            tweenRepeat.loop(true);
            tweenRepeat.yoyo(true);

            function _startTweenRepeat() {
                tweenRepeat.start();
            }

            tween = game.add.tween(obj);
            tween.to({
                alpha: 1
            }, Phaser.Timer.SECOND * 0.2, Phaser.Easing.Quadratic.Out);
            tween.onComplete.add(_startTweenRepeat, this);
            tween.start();

            U.LocalFx.smallGuiFx(obj.x, obj.y, 0.5, "smallGuiFx", 50);
        }

        this.hideBonusIndicator = function() {
            if (Lib.check.exists(obj)) {
                tween.stop();
                tweenRepeat.stop();
                obj.destroy();
            }
        }

        // STANDARD REPO CODE - ----------------------------------------
        repo.addObj(this);
        this.destroyWasCalled = false;
        //REQUIRED-----------------
        this.destroy = function() {
                if (!self.destroyWasCalled) {
                    p("DESTORYNIG SCORE MULT");
                    repo.removeObj(self);
                    self.destroyWasCalled = true;

                    if (Lib.check.exists(obj)) {
                        tween.stop();
                        tweenRepeat.stop();
                        obj.destroy();
                    }
                }
            }
            //OPTIONAL--------------------

        this._update = function() {
            // p("Im a BOx Emitter");
        }

    }

    function SingleBonusShow(bonusName = "Max Trajectory", y = 80, fill = "#0eff8b", val = 9) {
        var self = this;
        var group = U.GLOB.GROUPS.gui;
        var objNameText = undefined;
        var objValText = undefined;
        var pos = new Phaser.Point(655, y);
        var bonusName = bonusName;
        var bonusNameSize = "15px";
        var val = val;

        var styleName = {
            font: bonusNameSize + " peace_sans",
            fill: fill,
            stroke: "#193025",
            strokeThickness: 3.5
        }

        objNameText = Lib.UTILS.createTextInGroup(pos.x, pos.y, bonusName, styleName, group);
        objNameText.anchor.x = 1;
        objNameText.anchor.y = 0;
        objNameText.alpha = 0;

        objValText = Lib.UTILS.createTextInGroup(pos.x + 10, pos.y, "x" + val.toString(), styleName, group);
        objValText.anchor.x = 0;
        objValText.anchor.y = 0;

        var nameTween = game.add.tween(objNameText);
        nameTween.to({
            alpha: 1
        }, Phaser.Timer.SECOND * 0.5, Phaser.Easing.Quadratic.Out);
        nameTween.start();

        var valTween = game.add.tween(objValText);
        valTween.to({
            alpha: 1
        }, Phaser.Timer.SECOND * 0.5, Phaser.Easing.Quadratic.Out);
        valTween.start();

        U.LocalFx.smallGuiFx(objValText.x + objValText.width / 2, objValText.y + objValText.height / 2, 0.3, "smallGuiFx", 50);
        U.LocalFx.smallGuiFx(objNameText.x - 100, objNameText.y + objNameText.height / 2, 0.3, "smallGuiFx", 50);
        U.LocalFx.smallGuiFx(objNameText.x - 60, objNameText.y + objNameText.height / 2, 0.3, "smallGuiFx", 50);
        U.LocalFx.smallGuiFx(objNameText.x - 20, objNameText.y + objNameText.height / 2, 0.3, "smallGuiFx", 50);


        // STANDARD REPO CODE - ----------------------------------------
        repo.addObj(this);
        this.destroyWasCalled = false;
        //REQUIRED-----------------
        this.destroy = function() {
                if (!self.destroyWasCalled) {
                    p("DESTORYNIG SCORE MULT");
                    repo.removeObj(self);
                    self.destroyWasCalled = true;

                    if (Lib.check.exists(objNameText)) {
                        nameTween.stop();
                        objNameText.destroy();
                    }

                    if (Lib.check.exists(objValText)) {
                        valTween.stop();
                        objValText.destroy();
                    }
                }
            }
            //OPTIONAL--------------------

        this._update = function() {
            // p("Im a BOx Emitter");
        }

    }

    function BonusDisplay() {
        var self = this;
        var maxTrajectory = undefined;
        var ghostObstacles = undefined;
        var startY = 440;

        this.setValMaxTrajectory = function(val) {
            if (Lib.check.exists(maxTrajectory)) {
                maxTrajectory.destroy();
            }


            if (val > 0)
                maxTrajectory = new SingleBonusShow("Max. Trajectory", startY, "#0eff8b", val);
        }

        this.setValGhostObstacles = function(val) {
            if (Lib.check.exists(ghostObstacles)) {
                ghostObstacles.destroy();
            }

            if (val > 0)
                ghostObstacles = new SingleBonusShow("Ghost Obstacles", startY - 20, "#0efffc", val);

        }
    }

    function MenuStick() {
        var self = this;
        var group = U.GLOB.GROUPS.aboveGrass;
        var poleTex = "menuPole";
        var playButtonTex = "playButtonMenu";
        var highscoreBackgroundTex = "highscoreBackgroundMenu";
        var creditsButtonTex = "creditsButton";

        var showPos = new Phaser.Point(game.world.width / 2, game.world.height / 2);
        var hidePos = new Phaser.Point(-150, game.world.height / 2);
        // var hidePos = new Phaser.Point(300,200);

        var poleOffset = new Phaser.Point(90, 96);
        var playButtonOffset = new Phaser.Point(5, -27);
        var highscoreBackgroundOffset = new Phaser.Point(3, 120);
        var highScoreTextOffset = new Phaser.Point(5, 133);
        var soundButtonOffset = new Phaser.Point(2, 56);
        var creditsButtonOffset = new Phaser.Point(2,184);

        this.poleObj = new Lib.Gui.Image({
            x: hidePos.x + poleOffset.x,
            y: hidePos.y + poleOffset.y,
            texture: poleTex,
            group: group,
            anchor: new Phaser.Point(0.5, 0.5)
        });

        this.playButtonObj = new Lib.Gui.Button({
            x: hidePos.x + playButtonOffset.x,
            y: hidePos.y + playButtonOffset.y,
            texture: playButtonTex,
            group: group,
            callback: U.GLOB.FACTORY.stateManager.playClickedFromMenu,
            context: U.GLOB.FACTORY.stateManager.context
        });
        U.GLOB.BUTTONS.playFromMenu = self.playButtonObj;

        this.soundButtonObj = new Lib.Gui.ButtonToggle({
            x: hidePos.x + soundButtonOffset.x,
            y: hidePos.y + soundButtonOffset.y,
            textureTrue: "soundOnButton",
            textureFalse: "soundOffButton",
            group: group,
            callback: U.GLOB.FACTORY.stateManager.soundClickedFromMenu,
            context: U.GLOB.FACTORY.stateManager.context

        });
        U.GLOB.BUTTONS.soundFromMenu = self.soundButtonObj;

        this.creditsButtonObj = new Lib.Gui.Button({
            x: hidePos.x + creditsButtonOffset.x,
            y: hidePos.y + creditsButtonOffset.y,
            texture: creditsButtonTex,
            group: group,
            callback: U.GLOB.FACTORY.stateManager.creditsClickedFromMenu,
            context: U.GLOB.FACTORY.stateManager.context 
        });
        U.GLOB.BUTTONS.creditsFromMenu = self.creditsButtonObj;


        this.highscoreBackgroundObj = new Lib.Gui.Image({
            x: hidePos.x + highscoreBackgroundOffset.x,
            y: hidePos.y + highscoreBackgroundOffset.y,
            texture: highscoreBackgroundTex,
            group: group,
            anchor: new Phaser.Point(0.5, 0.5)
        });

        this.highScoreTextObj = new Lib.Gui.Text({
            x: hidePos.x + highScoreTextOffset.x,
            y: hidePos.y + highScoreTextOffset.y,
            text: U.STATS.getHighScore().toString(),
            anchor: new Phaser.Point(0.5, 0.5),
            style: {
                font: "29px peace_sans",
                fill: "#fff600",
                // fill: "#efffb9",
                stroke: "#322213",
                strokeThickness: 4
            },
            group: group
        });

        // STANDARD REPO CODE - ----------------------------------------
        repo.addObj(this);
        this.destroyWasCalled = false;
        //REQUIRED-----------------
        this.destroy = function() {
            if (!self.destroyWasCalled) {
                repo.removeObj(self);
                self.destroyWasCalled = true;

                poleObj.destroy();
                playButtonObj.destroy();
                highscoreBackgroundObj.destroy();
                highScoreTextObj.destroy();
                soundButtonObj.destroy();
                creditsButtonObj.destroy();
            }
        }

        this._update = function() {
            setYBasedONTweeningY();
        }


        //#######################
        this.tweeningY = hidePos.x;
        var oldTweeningY = self.tweeningY;

        function setYBasedONTweeningY() {
            if (oldTweeningY !== self.tweeningY) {
                _setX(self.tweeningY);
                oldTweeningY = self.tweeningY;
            }
        }

        function _setX(x) {
            // self.objBackground.obj.y = y;
            // self.objText.obj.y = y + textOffset.y;
            self.poleObj.obj.x = x + poleOffset.x;
            self.playButtonObj.obj.x = x + playButtonOffset.x;
            self.highscoreBackgroundObj.obj.x = x + highscoreBackgroundOffset.x;
            self.highScoreTextObj.obj.x = x + highScoreTextOffset.x;
            self.soundButtonObj.obj.x = x + soundButtonOffset.x;
            self.creditsButtonObj.obj.x = x + creditsButtonOffset.x;
        }

        //AUTO HIDE SHOW
        var showTween = game.add.tween(self);


        this.show = function(seconds = 0.5) {
            showTween.manager.remove(showTween);
            showTween = game.add.tween(self);
            showTween.to({
                tweeningY: showPos.x
            }, Phaser.Timer.SECOND * seconds, Phaser.Easing.Quadratic.Out);
            showTween.start();

            self.highScoreTextObj.setText(U.STATS.getHighScore().toString());

        }

        this.hide = function(seconds = 0.5) {
            // showTween.stop();
            showTween.manager.remove(showTween);
            showTween = game.add.tween(self);
            showTween.to({
                tweeningY: hidePos.x
            }, Phaser.Timer.SECOND * seconds, Phaser.Easing.Quadratic.In);
            showTween.start();
        }

    }

    function MenuCovers() {
        var self = this;
        var group = U.GLOB.GROUPS.aboveGui;
        // var vignetteTex = "menuVignette";
        // var vignetteHideAlpha = 0;
        // var vignetteShowAlpha = 1;
        var blurredTreesTex = "blurredTrees";
        var blurredTreesShowPos = new Phaser.Point(0, -180);
        var blurredTreesHidePos = new Phaser.Point(0, 1200);

        var tempBall = undefined;
        var tempBallEvent = undefined;

        this.blurredTreesObj = new Lib.Gui.Image({
            x: blurredTreesShowPos.x,
            y: blurredTreesHidePos.y,
            texture: blurredTreesTex,
            group: U.GLOB.GROUPS.aboveGrass,
            anchor: new Phaser.Point(0, 0)
        });

        // this.vignetteObj = new Lib.Gui.Image({
        //     x: 0,
        //     y: 0,
        //     texture: vignetteTex,
        //     group: group,
        //     anchor: new Phaser.Point(0, 0),
        //     blendMode: Phaser.blendModes.MULTIPLY
        // });
        // this.vignetteObj.obj.alpha = vignetteHideAlpha;

        // STANDARD REPO CODE - ----------------------------------------
        repo.addObj(this);
        this.destroyWasCalled = false;
        //REQUIRED-----------------
        this.destroy = function() {
                if (!self.destroyWasCalled) {
                    p("DESTORYNIG SCORE MULT");
                    repo.removeObj(self);
                    self.destroyWasCalled = true;

                    if (Lib.check.exists(objNameText)) {
                        nameTween.stop();
                        objNameText.destroy();
                    }

                    if (Lib.check.exists(objValText)) {
                        valTween.stop();
                        objValText.destroy();
                    }
                }
            }
            //OPTIONAL--------------------

        this._update = function() {
            // p("Im a BOx Emitter");
        }

        //var vignette hide/show tween
        // this.tweeningAlpha = vignetteHideAlpha;
        // var alphaTween = game.add.tween(self.vignetteObj.obj);

        this.showVignette = function(seconds = 0.5) {
            // alphaTween.manager.remove(alphaTween);
            // alphaTween = game.add.tween(self.vignetteObj.obj);
            // alphaTween.to({
            //     alpha: vignetteShowAlpha
            // }, Phaser.Timer.SECOND * seconds, Phaser.Easing.Quadratic.Out);
            // alphaTween.start();
        }

        this.hideVignette = function(seconds = 0.5) {
            // alphaTween.manager.remove(alphaTween);
            // alphaTween = game.add.tween(self.vignetteObj.obj);
            // alphaTween.to({
            //     alpha: vignetteHideAlpha
            // }, Phaser.Timer.SECOND * seconds, Phaser.Easing.Quadratic.In);
            // alphaTween.start();
        }

        //blurred trees hide/show tween 
        var blurredTreesTween = game.add.tween(self.blurredTreesObj.obj);
        this.showBlurredTrees = function(seconds = 0.5) {

            self.blurredTreesObj.obj.y = blurredTreesShowPos.y;
            self.blurredTreesObj.obj.alpha = 0;

            blurredTreesTween.manager.remove(blurredTreesTween);
            blurredTreesTween = game.add.tween(self.blurredTreesObj.obj);
            blurredTreesTween.to({
                alpha:1
            }, Phaser.Timer.SECOND * seconds, Phaser.Easing.Quadratic.Out);
            blurredTreesTween.start();
        }

        this.hideBlurredTrees = function(seconds = 0.5) {
                blurredTreesTween.manager.remove(blurredTreesTween);
                blurredTreesTween = game.add.tween(self.blurredTreesObj.obj);
                blurredTreesTween.to({
                    y: blurredTreesHidePos.y
                }, Phaser.Timer.SECOND * seconds, Phaser.Easing.Quadratic.In);
                blurredTreesTween.start();
            }
            //create ball
        this.createTempBall = function(seconds = 2) {
            tempBallEvent = game.time.events.add(Phaser.Timer.SECOND * seconds, _createBall, self);
        }
        this.destroyTempBall = function() {
            if (Lib.check.exists(tempBallEvent)) {
                game.time.events.remove(tempBallEvent);
            }
            _destroyBall();
        }

        function _createBall() {
            // tempBall = new U.GameObjects.Ball(100,100,false,U.GLOB.GROUPS.foregroundTrees);
            // U.GLOB.FACTORY.ballFactory.createBall(100,100);
            tempBall = new U.GameObjects.Ball(210, 100, false, true);
        }

        function _destroyBall() {
            if (Lib.check.exists(tempBall)) {
                tempBall.destroy();
            }
        }

    }

    function MenuGui() {
        var self = this;
        var menuCovers = new MenuCovers();
        var menuStick = new MenuStick();

        self.showGui = function() {
            menuStick.show(0.8);
        }
        self.hideGui = function() {
            menuStick.hide(0.5);
        }
        self.showVignette = function(seconds = 1) {
            menuCovers.showVignette(seconds);
        }
        self.hideVignette = function(seconds = 0.5) {
            menuCovers.hideVignette(seconds);
        }
        self.showBlurredTrees = function(seconds = 1.8) {
            menuCovers.showBlurredTrees(seconds);
        }
        self.hideBlurredTrees = function(seconds = 0.7) {
            menuCovers.hideBlurredTrees(seconds);
        }
        self.showBall = function() {
            menuCovers.createTempBall(1.5);
        }
        self.hideBall = function() {
            menuCovers.destroyTempBall();
        }

    }

    function EndGameBlock() {
        var self = this;
        var group = U.GLOB.GROUPS.aboveGrass;
        var backgroundTex = "endGameBackground";

        var showPos = new Phaser.Point(85, 80);
        var hidePos = new Phaser.Point(-560, 80);

        var highScoreTextOffset = new Phaser.Point(168, 103);
        var accuracyTextOneOffset = new Phaser.Point(168, 171);
        var accuracyTextTwoOffset = new Phaser.Point(168, 187);
        var comboObjOffset = new Phaser.Point(168, 249);
        var scoreTextOffset = new Phaser.Point(382, 103);
        var playButtonOffset = new Phaser.Point(382, 243);
        var menuButtonOffset = new Phaser.Point(383, 177);

        var textStyle = {
            font: "27px peace_sans",
            fill: "#fffa6a",
            // fill: "#efffb9",
            stroke: "#322213",
            strokeThickness: 4
        }

        var textStyleSmall = {
            font: "16px peace_sans",
            fill: "#fffa6a",
            // fill: "#efffb9",
            stroke: "#322213",
            strokeThickness: 2
        }

        var textStyleVerySmall = {
            font: "12px peace_sans",
            fill: "#fffa6a",
            // fill: "#efffb9",
            stroke: "#322213",
            strokeThickness: 2
        }


        //-----------------------------------------------
        this.backgroundObj = new Lib.Gui.Image({
            x: hidePos.x,
            y: hidePos.y,
            texture: backgroundTex,
            group: group,
            anchor: new Phaser.Point(0, 0)
        });

        this.highScoreTextObj = new Lib.Gui.Text({
            x: hidePos.x + highScoreTextOffset.x,
            y: hidePos.y + highScoreTextOffset.y,
            text: U.STATS.getHighScore().toString(),
            style: textStyle,
            group: group,
            anchor: new Phaser.Point(0.5, 0.5)
        });

        this.accuracyTextOneObj = new Lib.Gui.Text({
            x: hidePos.x + accuracyTextOneOffset.x,
            y: hidePos.y + accuracyTextOneOffset.y,
            text: U.STATS.getTotalScored().toString() + " out of " + U.STATS.getTotalLaunched().toString(),
            style: textStyleSmall,
            group: group,
            anchor: new Phaser.Point(0.5, 0.5)
        });

        this.accuracyTextTwoObj = new Lib.Gui.Text({
            x: hidePos.x + accuracyTextTwoOffset.x,
            y: hidePos.y + accuracyTextTwoOffset.y,
            text: U.STATS.getAccuracy().toFixed(1).toString() + "%",
            style: textStyleVerySmall,
            group: group,
            anchor: new Phaser.Point(0.5, 0.5)
        });

        this.comboObj = new Lib.Gui.Image({
            x: hidePos.x + comboObjOffset.x,
            y: hidePos.y + comboObjOffset.y,
            texture: _getTexBasedOnVal(U.STATS.getMaxCombo()),
            group: group,
            anchor: new Phaser.Point(0.5, 0.5)
        });

        this.scoreTextObj = new Lib.Gui.Text({
            x: hidePos.x + scoreTextOffset.x,
            y: hidePos.y + scoreTextOffset.y,
            text: U.STATS.getCurrentScore().toString(),
            style: textStyle,
            group: group,
            anchor: new Phaser.Point(0.5, 0.5)
        });

        this.playButtonObj = new Lib.Gui.Button({
            x: hidePos.x + playButtonOffset.x,
            y: hidePos.y + playButtonOffset.y,
            texture: "endGamePlay",
            group: group,
            callback: U.GLOB.FACTORY.stateManager.playClickedFromGameOver,
            context: U.GLOB.FACTORY.stateManager.context,
            anchor: new Phaser.Point(0.5, 0.5)
        });

        U.GLOB.BUTTONS.playFromEndGame = self.playButtonObj;

        this.menuButtonObj = new Lib.Gui.Button({
            x: hidePos.x + menuButtonOffset.x,
            y: hidePos.y + menuButtonOffset.y,
            texture: "endGameMenu",
            group: group,
            callback: U.GLOB.FACTORY.stateManager.menuClickedFromGameOver,
            context: U.GLOB.FACTORY.stateManager.context,
            anchor: new Phaser.Point(0.5, 0.5)
        });

        U.GLOB.BUTTONS.menuFromEndGame = self.menuButtonObj;

        //UTILITY FUNC
        function _getTexBasedOnVal(val) {
            var tex = "";
            if (val >= 2 && val <= 10) {
                tex = "prevCombo" + val.toString();
            }
            else if (val >= 11 && val <= 12) {
                tex = "prevComboMega";
            }
            else if (val >= 13 && val <= 14) {
                tex = "prevComboSuperMega";
            }
            else if (val >= 15) {
                tex = "prevComboFantastic";
            }
            return tex;
        }

        // STANDARD REPO CODE - ----------------------------------------
        repo.addObj(this);
        this.destroyWasCalled = false;
        //REQUIRED-----------------
        this.destroy = function() {
            if (!self.destroyWasCalled) {
                repo.removeObj(self);
                self.destroyWasCalled = true;

                self.backgroundObj.destroy();
                self.highScoreTextObj.destroy();
                self.accuracyTextOneObj.destroy();
                self.accuracyTextTwoObj.destroy();
                self.comboObj.destroy();
                self.scoreTextObj.destroy();
                self.playButtonObj.destroy();
                self.menuButtonObj.destroy();
            }
        }

        this._update = function() {
            // setYBasedONTweeningY();
            setXBasedONTweeningX();
        }

        //#################################
        this.tweeningX = hidePos.x;
        var oldTweeningX = self.tweeningX;

        function setXBasedONTweeningX() {
            if (oldTweeningX !== self.tweeningX) {
                _setX(self.tweeningX);
                oldTweeningX = self.tweeningX;
            }
        }

        function _setX(x) {
            self.backgroundObj.obj.x = x;
            self.highScoreTextObj.obj.x = x + highScoreTextOffset.x;
            self.accuracyTextOneObj.obj.x = x + accuracyTextOneOffset.x;
            self.accuracyTextTwoObj.obj.x = x + accuracyTextTwoOffset.x;
            self.comboObj.obj.x = x + comboObjOffset.x;
            self.scoreTextObj.obj.x = x + scoreTextOffset.x;
            self.playButtonObj.obj.x = x + playButtonOffset.x;
            self.menuButtonObj.obj.x = x + menuButtonOffset.x;
        }

        //auto hide show
        var showTween = game.add.tween(self);
        //
        this.show = function(seconds = 0.5) {
            // U.GLOB.FACTORY.music.gameOverTrack.volume(1);
            U.GLOB.FACTORY.music.gameOverTrack.play();
            // U.GLOB.FACTORY.music.mainTrack.stop();
            showTween.manager.remove(showTween);
            showTween = game.add.tween(self);
            showTween.to({
                tweeningX: showPos.x
            }, Phaser.Timer.SECOND * seconds, Phaser.Easing.Quadratic.Out);
            showTween.start();
        }

        this.hide = function(seconds = 0.5) {
            // U.GLOB.FACTORY.music.gameOverTrack.fade(1,0,1000);
            // U.GLOB.FACTORY.music.mainTrack.play();
            showTween.manager.remove(showTween);
            showTween = game.add.tween(self);
            showTween.to({
                tweeningX: hidePos.x
            }, Phaser.Timer.SECOND * seconds, Phaser.Easing.Quadratic.In);
            // showTween.onComplete.add(self.destroy,self);
            showTween.start();

        }
    }

    function EndGameGui() {
        var self = this;
        var endGameBlock = new EndGameBlock();

        self.showGui = function() {
            endGameBlock.destroy();
            endGameBlock = new EndGameBlock();
            endGameBlock.show(0.6);
        }

        self.hideGui = function() {
            endGameBlock.hide(0.4);
        }
    }

    function PauseGui() {
        var self = this;
        var group = U.GLOB.GROUPS.pauseGui;

        this.showGui = function() {
            self.backgroundObj = new Lib.Gui.Image({
                x: 0,
                y: 0,
                texture: "pausedBackground",
                group: group,
                anchor: new Phaser.Point(0, 0)
            });
            self.backgroundObj.obj.alpha = 1;
            self.backgroundObj.obj.blendMode = Phaser.blendModes.MULTIPLY;

            self.pausedGraphicObj = new Lib.Gui.Image({
                x: game.world.width / 2,
                y: 130,
                texture: "pausedGraphic",
                group: group,
                anchor: new Phaser.Point(0.5, 0.5)
            })

            this.resumeButton = new Lib.Gui.Button({
                x: game.world.width / 2,
                y: 320,
                texture: "pauseResumeButton",
                group: group,
                callback: U.GLOB.FACTORY.stateManager.resumeClickedFromPause,
                context: U.GLOB.FACTORY.stateManager.context,
                anchor: new Phaser.Point(0.5, 0.5)
            });

            U.GLOB.BUTTONS.resumeFromPause = self.resumeButton;
            U.GLOB.OTHER.resumeButtonRect = new Phaser.Rectangle(self.resumeButton.obj.x - self.resumeButton.obj.width / 2, self.resumeButton.obj.y - self.resumeButton.obj.height / 2, self.resumeButton.obj.width, self.resumeButton.obj.height);

            this.menuButton = new Lib.Gui.Button({
                x: game.world.width / 2,
                y: 390,
                texture: "pauseMenuButton",
                group: group,
                callback: U.GLOB.FACTORY.stateManager.menuClickedFromPause,
                context: U.GLOB.FACTORY.stateManager.context,
                anchor: new Phaser.Point(0.5, 0.5)
            });

            U.GLOB.BUTTONS.menuFromPause = self.menuButton;
            U.GLOB.OTHER.menuButtonRect = new Phaser.Rectangle(self.menuButton.obj.x - self.menuButton.obj.width / 2, self.menuButton.obj.y - self.menuButton.obj.height / 2, self.menuButton.obj.width, self.menuButton.obj.height);
        }

        this.hideGui = function() {
            self.backgroundObj.obj.destroy();
            self.pausedGraphicObj.obj.destroy();
            self.resumeButton.obj.destroy();
            self.menuButton.obj.destroy();
        }

    }

    function TutorialHand() {
        var self = this;
        var group = U.GLOB.GROUPS.gui;
        var texture = "tutHand";

        var hidePos = new Phaser.Point(-2000,-2000);

        this.obj = new Lib.Gui.Image({
            x: hidePos.x,
            y: hidePos.y,
            texture: texture,
            group: group,
            anchor: new Phaser.Point(0, 0)
        });
        this.obj.obj.alpha=0;

        var tween = game.add.tween(this.obj.obj);

        this.show = function(startPos) {
            var xOffset = 100;
            self.obj.obj.x = startPos.x - xOffset;
            self.obj.obj.y = startPos.y;
            self.obj.obj.alpha = 0;

            var endPos = new Phaser.Point(startPos.x + 100 - xOffset, startPos.y + 100);

            tween.manager.remove(tween);
            tween = game.add.tween(self.obj.obj);
            tween.to({
                alpha: 1
            }, Phaser.Timer.SECOND * 0.5, Phaser.Easing.Quadratic.In,false,1000);
            tween.to({
                x: endPos.x,
                y: endPos.y
            }, Phaser.Timer.SECOND * 0.9, Phaser.Easing.Quadratic.InOut,false,500);
            tween.to({
                alpha: 0
            }, Phaser.Timer.SECOND * 0.4, Phaser.Easing.Quadratic.Out);

            tween.loop(true);
            tween.start();
        }

        this.hide = function(){
            tween.manager.remove(tween);
            self.obj.obj.x = hidePos.x;
            self.obj.obj.y = hidePos.y;
            self.obj.obj.alpha=0;
        }

        // this.show(new Phaser.Point(100,100));

    }

    function TutorialGui() {
        var self = this;
        var tutorialHand = new TutorialHand();

        this.showGui = function(startPos) {
            tutorialHand.show(startPos);
        }
        this.hideGui = function(){
            tutorialHand.hide();
        }
    }

    function CreditsGui(){
        var self = this;
        var texture = "creditsScreen";
        var group = U.GLOB.GROUPS.pauseGui;

        var showPos = new Phaser.Point(0,0);
        var hidePos = new Phaser.Point(-2000,-2000);

        this.creditsObj = new Lib.Gui.Button({
            x:hidePos.x,
            y:hidePos.y,
            texture:texture,
            group:group,
            anchor:new Phaser.Point(0,0),
            callback: _hideGui,
            context:this
        });
        this.creditsObj.obj.alpha = 0;

        var tween = game.add.tween(self.creditsObj.obj);

        this.showGui = function(){
            tween.manager.remove(tween);
            tween =game.add.tween(self.creditsObj.obj);
            self.creditsObj.obj.x = showPos.x;
            self.creditsObj.obj.y = showPos.y;
            tween.to({alpha:1}, Phaser.Timer.SECOND * 0.4, Phaser.Easing.Quadratic.Out);
            tween.start();
        }

        function _hideGui (){
            tween.manager.remove(tween);
            tween =game.add.tween(self.creditsObj.obj);
            tween.to({alpha:0}, Phaser.Timer.SECOND * 0.2, Phaser.Easing.Quadratic.Out);
            self.creditsObj.obj.x = hidePos.x;
            self.creditsObj.obj.y = hidePos.y;
            tween.start();
        }

    }

    function MainGameGui() {
        var self = this;
        var ballNumber = new BallNumber();
        var scoreNumber = new ScoreNumber();
        var scoreMultiplier = new ScoreMultiplier();
        var gameDiff = new GameDiff();
        var baseScore = new BaseScore();
        var bonusIndicator = new BonusIndicator();
        var bonusDisplay = new BonusDisplay();
        var pauseButton = new PauseButton();
        var comboGraphic = undefined;
        var comboGraphicEvent = undefined;
        var comboShowDelay = 0.5;



        self.addBalls = function(numOfBalls) {
            // p("ADDING A BALL");
            ballNumber.setVal(ballNumber.textVal + numOfBalls);
        }
        self.substractBalls = function(numOfBalls) {
            ballNumber.setVal(ballNumber.textVal - numOfBalls);
        }

        self.setAbsBallsVal = function(numOfBalls) {
            ballNumber.setAbsVal(numOfBalls);
        }

        self.addScore = function(val) {
            scoreNumber.addScore(val);
        }

        self.showCombo = function(val) {
            // comboGraphic.destroy();
            if (Lib.check.objHasMethod(comboGraphic, "destroy")) {
                comboGraphic.destroy();
            }
            game.time.events.remove(comboGraphicEvent);
            comboGraphicEvent = game.time.events.add(Phaser.Timer.SECOND * comboShowDelay, _createComboGraphic, self, val);
        }

        self.showScoreMultiplier = function(val, withFx = true) {

            scoreMultiplier.showScoreMultiplier(val, withFx);
        }

        self.showDiff = function(diff, withFx = true) {
            gameDiff.showDiff(diff, withFx);
        }

        self.showBaseScore = function(diff, withFx = true) {
            baseScore.showBaseScore(diff, withFx);
        }

        self.showBonusIndicator = function() {
            bonusIndicator.showBonusIndicator();
        }

        self.hideBonusIndicator = function() {
            bonusIndicator.hideBonusIndicator();
        }

        self.setValGhostObstacles = function(val) {
            bonusDisplay.setValGhostObstacles(val);
        }

        self.setValMaxTrajectory = function(val) {
            bonusDisplay.setValMaxTrajectory(val);
        }

        //######################################
        //HIDE SHOW main gui
        var ballEvent = undefined;
        var scoreEvent = undefined;
        var appearsGuiEvent = undefined;
        var pauseButtonEvent = undefined;

        self.hideGui = function() {
            _removeEvents();
            ballEvent = game.time.events.add(Phaser.Timer.SECOND * 0.2, ballNumber.hide, self);
            scoreEvent = game.time.events.add(Phaser.Timer.SECOND * 0.3, scoreNumber.hide, self);
            appearsGuiEvent = game.time.events.add(Phaser.Timer.SECOND * 0.1, _hideOtherGui, self);
            pauseButtonEvent = game.time.events.add(Phaser.Timer.SECOND * 0.4, pauseButton.hide, self);
        }


        self.showGui = function() {
            _removeEvents();
            ballEvent = game.time.events.add(Phaser.Timer.SECOND * 0.3, ballNumber.show, self);
            scoreEvent = game.time.events.add(Phaser.Timer.SECOND * 0.2, scoreNumber.show, self);
            appearsGuiEvent = game.time.events.add(Phaser.Timer.SECOND * 1.1, _showOtherGui, self);
            pauseButtonEvent = game.time.events.add(Phaser.Timer.SECOND * 0.1, pauseButton.show, self);

            // ballNumber.show();
            // scoreNumber.show();
            // _hideOtherGui();
        }

        //helper funcs
        function _hideOtherGui() {
            self.showScoreMultiplier(0, false);
            self.showBaseScore("", false);
            self.showDiff("", false);
            self.setValGhostObstacles(0);
            self.setValMaxTrajectory(0);

            self.hideBonusIndicator();
        }

        function _showOtherGui() {
            self.showScoreMultiplier(U.STATS.currentComboChain);
            self.showBaseScore(U.STATS.diff);
            self.showDiff(U.STATS.diff);
            self.setValGhostObstacles(U.STATS.bonusCountGhostObstacles);
            self.setValMaxTrajectory(U.STATS.bonusCountMaxTraj);
        }

        function _removeEvents() {
            if (Lib.check.exists(ballEvent)) {
                game.time.events.remove(ballEvent);
            }
            if (Lib.check.exists(scoreEvent)) {
                game.time.events.remove(scoreEvent);
            }
            if (Lib.check.exists(appearsGuiEvent)) {
                game.time.events.remove(appearsGuiEvent);
            }

            if (Lib.check.exists(pauseButtonEvent)) {
                game.time.events.remove(pauseButtonEvent);
            }
        }


        //DEBUG FUNC
        // self._doStuff = function() {
        //     var y = new SingleBonusShow("Ghost Obstacles", 80, "#0efffc");
        //     var x = new SingleBonusShow("Max. Trajectory", 100, "#0eff8b");
        // }

        function _createComboGraphic(val) {
            comboGraphic = new ComboGraphic(val);
        }

        //FINISHING CALLS

        //automatically hide appears gui
        _hideOtherGui();

    }


    //------------------MAIN MENU-------------------------------------------------


    function GuiManager() {
        var self = this;
        p("Creating GUi Manager");
        this.mainGameGui = undefined;
        this.menuGui = undefined;
        this.endGameGui = undefined;
        this.pauseGui = undefined;
        this.tutorialGui = undefined;
        this.creditsGui = undefined;

        this.createTutorialGui = function() {
            self.tutorialGui = new TutorialGui();
        }

        this.createMainGameGui = function() {
            self.mainGameGui = new MainGameGui();
        }

        this.createMenuGui = function() {
            self.menuGui = new MenuGui();
        }

        this.createEndGameGui = function() {
            self.endGameGui = new EndGameGui();
        }

        this.createPauseGui = function() {
            self.pauseGui = new PauseGui();
        }

        this.createCreditsGui = function(){
            self.creditsGui = new CreditsGui();
        }
    }
    obj.GuiManager = GuiManager;

    //
    return obj;
}());
